﻿XIncludeFile #PB_Compiler_Home + "Includes\Imports\BCL_Import.pbi"

; Simple Access.....  

Enumeration 
  #BCL_ALGO_RLE
  #BCL_ALGO_HUFFMAN
  #BCL_ALGO_LZ
  #BCL_ALGO_SF 
  #BCL_ALGO_RICE 
  #BCL_ALGO_RICE_U8 
  #BCL_ALGO_RICE_8 
  #BCL_ALGO_RICE_U16
  #BCL_ALGO_RICE_16 
  #BCL_ALGO_RICE_U32
  #BCL_ALGO_RICE_32
EndEnumeration

Procedure BCL_PackToMemory(filename.s, algo.l, *o_outsize.l, flag.l = 0)
  Define fp.l, insize.l
  Define outsize.l,*in.l,*buf.l
  
  fp.l = OpenFile(#PB_Any,filename)
  If fp
    insize.l = FileSize(filename)
    If insize > 0
      ;/ Worst Case output Buffer Size
      bufsize.l = ((insize*104)+50)/100 + 384;
      
      ;/ Allocate memory 
      *in = AllocateMemory( insize + (1*bufsize) );
      If *in
        ;/ Pointers To compression Buffer And output memory
        *buf.l = *in+insize
        
        ;/ Read And close input FILE
        ReadData(fp,*in,insize)  
        CloseFile(fp)
        
        ;/ Compress And decompress
        Select ( algo )
          Case #BCL_ALGO_RLE:
            outsize.l = RLE_Compress( *in, *buf, insize ); 
          Case #BCL_ALGO_LZ:
            outsize.l = LZ_Compress( *in, *buf, insize ); 
          Case #BCL_ALGO_SF:
            outsize.l = SF_Compress( *in, *buf, insize ); 
          Case #BCL_ALGO_HUFFMAN:
            outsize.l = Huffman_Compress( *in, *buf, insize ); 
          Case #BCL_ALGO_RICE:
            outsize.l = Rice_Compress( *in, *buf, insize, flag ); 
        EndSelect
        
        
      Else 
        CloseFile(fp)
      EndIf
    Else 
      CloseFile(fp)
    EndIf
  EndIf
  *o_outsize = outsize
  ProcedureReturn *in;
EndProcedure 


; jaPBe Version=3.7.2.629
; Build=0
; CodePage=65001
; FirstLine=0
; CursorPosition=0
; ExecutableFormat=Windows
; DontSaveDeclare
; EOF