XIncludeFile #PB_Compiler_Home + "Includes\Imports\BCL_Import.pbi"
;{- Enumerations / DataSections
;{ Windows
Enumeration
  #Window_0
EndEnumeration
;}
;{ Gadgets
Enumeration
  #String_0
  #Button_1
  #Text_4
  #Button_Test
  #ListIcon_Results
EndEnumeration
;}
;}

; TestFile

Enumeration 
  #BCL_ALGO_RLE
  #BCL_ALGO_HUFFMAN
  #BCL_ALGO_LZ
  #BCL_ALGO_SF 
  #BCL_ALGO_RICE 
  #BCL_ALGO_RICE_U8 
  #BCL_ALGO_RICE_8 
  #BCL_ALGO_RICE_U16
  #BCL_ALGO_RICE_16 
  #BCL_ALGO_RICE_U32
  #BCL_ALGO_RICE_32
EndEnumeration


#CRNL = Chr(13)+Chr(10)

Structure _bcl_test_struct
  compressor_name.s
  compressor_id.l
  compression_rate.f
  compression_speed.l
  compression_kbs.f
  uncompression_speed.l
  uncompression_kbs.f
  orgsize.l
  compsize.l
EndStructure


NewList bcls._bcl_test_struct()

Procedure.s TestFile(filename.s, algo.l) 
  Shared bcls()
  AddElement(bcls())
  bcls()\compressor_id = algo
  OutText.s = "BCL-Test "
  Select algo
    Case #BCL_ALGO_HUFFMAN : OutText=OutText+"Huffman" + #CRNL : bcls()\compressor_name = "Huffman"
    Case #BCL_ALGO_LZ : OutText=OutText+"LZ" + #CRNL  : bcls()\compressor_name = "LZ"
    Case #BCL_ALGO_SF : OutText=OutText+"SF" + #CRNL  : bcls()\compressor_name = "SF"
    Case #BCL_ALGO_RLE : OutText=OutText+"RLE" + #CRNL  : bcls()\compressor_name = "RLE"
    Case #BCL_ALGO_RICE_U8 : OutText=OutText+"Rice (U8)" + #CRNL  : bcls()\compressor_name = "Rice (U8)"
    Case #BCL_ALGO_RICE_U16 : OutText=OutText+"Rice (U16)" + #CRNL : bcls()\compressor_name = "Rice (U16)"
    Case #BCL_ALGO_RICE_U32 : OutText=OutText+"Rice (U32)" + #CRNL: bcls()\compressor_name = "Rice (U32)" 
    Case #BCL_ALGO_RICE_8 : OutText=OutText+"Rice (8)" + #CRNL : bcls()\compressor_name = "Rice (8)"
    Case #BCL_ALGO_RICE_16 : OutText=OutText+"Rice (16)" + #CRNL : bcls()\compressor_name = "Rice (16)"
    Case #BCL_ALGO_RICE_32 : OutText=OutText+"Rice (32)" + #CRNL : bcls()\compressor_name = "Rice (32)"
  EndSelect
  t_comp.l = -1
  t_uncomp.l = -1
  fp.l = OpenFile(#PB_Any,filename)
  If fp
    insize.l = FileSize(filename)
    If insize > 0
      ;/ Worst Case output Buffer Size
      bufsize.l = ((insize*104)+50)/100 + 384;
      
      ;/ Allocate memory 
      *in = AllocateMemory( insize + (2*bufsize) );
      If *in
        ;/ Pointers To compression Buffer And output memory
        *buf.l = *in+insize
        *out.l = *buf+bufsize
        
        ;/ Read And close input FILE
        ReadData(fp,*in,insize)  
        CloseFile(fp)
        
        bcls()\orgsize = insize 
        
        ;/ Compress And decompress
        Select ( algo )
          Case #BCL_ALGO_RLE:
            t0.l = ElapsedMilliseconds()
            outsize.l = RLE_Compress( *in, *buf, insize ); 
            t_comp.l = ElapsedMilliseconds() - t0;
            t0.l = ElapsedMilliseconds()
            RLE_Uncompress( *buf, *out, outsize );
            t_uncomp.l = ElapsedMilliseconds() - t0;
          Case #BCL_ALGO_HUFFMAN:
            t0.l = ElapsedMilliseconds()
            outsize.l = Huffman_Compress( *in, *buf, insize ); 
            t_comp.l = ElapsedMilliseconds() - t0;
            t0.l = ElapsedMilliseconds()
            Huffman_Uncompress( *buf, *out, outsize, insize );
            t_uncomp.l = ElapsedMilliseconds() - t0;
          Case #BCL_ALGO_LZ:
            t0.l = ElapsedMilliseconds()
            outsize.l = LZ_Compress( *in, *buf, insize ); 
            t_comp.l = ElapsedMilliseconds() - t0;
            t0.l = ElapsedMilliseconds()
            LZ_Uncompress( *buf, *out, outsize);
            t_uncomp.l = ElapsedMilliseconds() - t0;
          Case #BCL_ALGO_SF:
            t0.l = ElapsedMilliseconds()
            outsize.l = SF_Compress( *in, *buf, insize ); 
            t_comp.l = ElapsedMilliseconds() - t0;
            t0.l = ElapsedMilliseconds()
            SF_Uncompress( *buf, *out, outsize, insize );
            t_uncomp.l = ElapsedMilliseconds() - t0;
            
          Case #BCL_ALGO_RICE_8:
            t0.l = ElapsedMilliseconds()
            outsize.l = Rice_Compress( *in, *buf, insize,#BCL_RICE_FMT_INT8 ); 
            t_comp.l = ElapsedMilliseconds() - t0;
            t0.l = ElapsedMilliseconds()
            Rice_Uncompress( *buf, *out, outsize, insize,#BCL_RICE_FMT_INT8 );
            t_uncomp.l = ElapsedMilliseconds() - t0;
            
          Case #BCL_ALGO_RICE_U8:
            t0.l = ElapsedMilliseconds()
            outsize.l = Rice_Compress( *in, *buf, insize,#BCL_RICE_FMT_UINT8 ); 
            t_comp.l = ElapsedMilliseconds() - t0;
            t0.l = ElapsedMilliseconds()
            Rice_Uncompress( *buf, *out, outsize, insize,#BCL_RICE_FMT_UINT8 );
            t_uncomp.l = ElapsedMilliseconds() - t0;
            
          Case #BCL_ALGO_RICE_16:
            t0.l = ElapsedMilliseconds()
            outsize.l = Rice_Compress( *in, *buf, insize,#BCL_RICE_FMT_INT16 ); 
            t_comp.l = ElapsedMilliseconds() - t0;
            t0.l = ElapsedMilliseconds()
            Rice_Uncompress( *buf, *out, outsize, insize,#BCL_RICE_FMT_INT16 );
            t_uncomp.l = ElapsedMilliseconds() - t0;
            
          Case #BCL_ALGO_RICE_U16:
            t0.l = ElapsedMilliseconds()
            outsize.l = Rice_Compress( *in, *buf, insize,#BCL_RICE_FMT_UINT16 ); 
            t_comp.l = ElapsedMilliseconds() - t0;
            t0.l = ElapsedMilliseconds()
            Rice_Uncompress( *buf, *out, outsize, insize,#BCL_RICE_FMT_UINT16 );
            t_uncomp.l = ElapsedMilliseconds() - t0;
            
          Case #BCL_ALGO_RICE_32:
            t0.l = ElapsedMilliseconds()
            outsize.l = Rice_Compress( *in, *buf, insize,#BCL_RICE_FMT_INT32 ); 
            t_comp.l = ElapsedMilliseconds() - t0;
            t0.l = ElapsedMilliseconds()
            Rice_Uncompress( *buf, *out, outsize, insize,#BCL_RICE_FMT_INT32 );
            t_uncomp.l = ElapsedMilliseconds() - t0;
            
          Case #BCL_ALGO_RICE_U32:
            t0.l = ElapsedMilliseconds()
            outsize.l = Rice_Compress( *in, *buf, insize,#BCL_RICE_FMT_UINT32 ); 
            t_comp.l = ElapsedMilliseconds() - t0;
            t0.l = ElapsedMilliseconds()
            Rice_Uncompress( *buf, *out, outsize, insize,#BCL_RICE_FMT_UINT32 );
            t_uncomp.l = ElapsedMilliseconds() - t0;
            
          Default:
            OutText=OutText+"We shoul never come To this.... "
            Debug("We shoul never come to this.... ")
        EndSelect
        
        
        
        err_count.l = 0;
        If outsize > 0
          ;/ Show compression result
          OutText=OutText+"   Compression: "+Str(outsize)+"/"+Str(insize)+" bytes ("+StrF(100*outsize/insize,2)+" % )"+#CRNL
          
          ;/ Compare input / output Data
          For k = 0 To insize-1
            If PeekB(*in+k) <> PeekB(*out+k)
              If err_count=0 : Debug("") : EndIf 
              If err_count=30 : Debug("   ...")
              ElseIf err_count<30
                Debug( "    "+Str(k)+": +"+Str(PeekB(*out+k))+" <> "+Str(PeekB(*in+k)));
              EndIf
              err_count+1 
            EndIf
          Next
          ;/ Did we have success?
          If  err_count = 0 
            f_comp.f = insize / (1024.0 * (t_comp/1000))
            f_uncomp.f = insize / (1024.0 * (t_uncomp/1000))
            
            bcls()\compression_rate = 100*outsize/insize
            bcls()\compsize = outsize
            bcls()\compression_kbs = f_comp
            bcls()\uncompression_kbs = f_uncomp
            bcls()\compression_speed = t_comp
            bcls()\uncompression_speed = t_uncomp
            
            ;            OutText=OutText+" - OK!"+#CRNL
            OutText=OutText+"    Compression-Speed: "+StrF(f_comp,1)+" KB/s ("+StrF(t_comp,2)+")"+#CRNL
            OutText=OutText+"    Uncompression-Speed: "+StrF(funcomp,1)+" KB/s ("+StrF(t_uncomp,2)+")"+#CRNL
          Else
            OutText=OutText+ "    *******************************" 
            OutText=OutText+ "    ERROR: "+Str(err_count)+" faulty Bytes" 
            OutText=OutText+ "    *******************************" 
          EndIf
        Else
          OutText=OutText+ "    Outsize was <= 0 : " +Str(outsize) 
          
        EndIf 
        
        ;/ Free all memory
        FreeMemory(*in) 
        ProcedureReturn OutText
      Else
        OutText=OutText+"out of memory!!" 
        CloseFile(fp)
      EndIf
      
    Else
      OutText=OutText+"empty file!" 
    EndIf 
  Else
    OutText=OutText+"unable to open " + filename + " !"
  EndIf
  
  ProcedureReturn OutText
EndProcedure



Procedure OpenWindow_Window_0()
  If OpenWindow(#Window_0, 440, 171, 400, 338, "BCL Test-Program", #PB_Window_SystemMenu|#PB_Window_SizeGadget|#PB_Window_MinimizeGadget|#PB_Window_TitleBar)
    If CreateGadgetList(WindowID(#Window_0))
      StringGadget(#String_0, 120, 25, 205, 20, "")
      ButtonGadget(#Button_1, 335, 25, 35, 20, "...")
      TextGadget(#Text_4, 1005, 25, 90, 20, "Select File to Test")
      ButtonGadget(#Button_Test, 20, 50, 80, 20, "TEST")
      ListIconGadget(#ListIcon_Results,10,100,380,225,"",100)
      AddGadgetColumn(#ListIcon_Results,0,"Algorithm",60)
      AddGadgetColumn(#ListIcon_Results,1,"insize",60)
      AddGadgetColumn(#ListIcon_Results,2,"outsize",60)
      AddGadgetColumn(#ListIcon_Results,3,"percent",60)
      AddGadgetColumn(#ListIcon_Results,4,"compress kb/s",60)
      AddGadgetColumn(#ListIcon_Results,5,"uncompress kb/s",60)
      
    EndIf
  EndIf
EndProcedure





OpenWindow_Window_0()

;{- Event loop
Repeat
  Event = WaitWindowEvent()
  Select Event
    ; ///////////////////
    Case #PB_Event_Gadget
      EventGadget = EventGadget()
      EventType = EventType()
      If EventGadget = #String_0
      ElseIf EventGadget = #Button_1
        File$ = OpenFileRequester("Bitte Datei zum Testen auswhlen", "", "Alle Dateien (*.*)|*.*", 0)
        If File$
          SetGadgetText(#String_0,File$)
        EndIf
      ElseIf EventGadget = #Button_Test
        ClearList(bcls())
        If Len(GetGadgetText(#String_0)) > 0
          tx.s = TestFile(GetGadgetText(#String_0),#BCL_ALGO_HUFFMAN)
          tx.s = tx + TestFile(GetGadgetText(#String_0),#BCL_ALGO_LZ)
          tx.s = tx + TestFile(GetGadgetText(#String_0),#BCL_ALGO_SF)
          tx = tx + TestFile(GetGadgetText(#String_0),#BCL_ALGO_RLE)
          tx = tx + TestFile(GetGadgetText(#String_0),#BCL_ALGO_RICE_8 )
          SortStructuredList(bcls(), 0, OffsetOf(_bcl_test_struct\compression_rate),#PB_Sort_Float)
          
          ClearGadgetItemList(#ListIcon_Results)
          count.l = 0
          ForEach bcls() 
            AddGadgetItem(#ListIcon_Results,-1,bcls()\compressor_name+Chr(10)+Str(bcls()\orgsize)+Chr(10)+Str(bcls()\compsize)+Chr(10)+StrF(bcls()\compression_rate,2)+Chr(10)+StrF(bcls()\compression_kbs,2)+Chr(10)+StrF(bcls()\uncompression_kbs,2))
          Next 
        
      EndIf
        
      EndIf
      ; //////////////////////
    Case #PB_Event_CloseWindow
      EventWindow = EventWindow()
      If EventWindow = #Window_0
        Break
      EndIf
  EndSelect
ForEver
;
;}

; jaPBe Version=3.7.2.629
; Build=0
; Language=0x0000 Language Neutral
; FirstLine=230
; CursorPosition=245
; ExecutableFormat=Windows
; DontSaveDeclare
; EOF